Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.server
Class S_LibraryService

    java.lang.Object
      oracle.ifs.server.S_LibraryService

All Implemented Interfaces:
  LibraryConstants, IfsEventHandler, Traceable

Direct Known Subclasses:
  S_TieLibraryService

    public class S_LibraryService

extends java.lang.Object
implements IfsEventHandler, Traceable, LibraryConstants

S_LibraryService is the iFS repository service.

An S_LibraryService hosts one or more user sessions, S_LibrarySessions. In addition to performing session management, the service provides a set of subservices shared by the sessions.

A Java VM can have one or more S_LibraryServices, each identified by a unique name. In establishing a connection, the user specifies the name of the desired service.

Application developers rarely need to operate on S_LibraryService. However, a reference to the service can be obtained by invoking the `getService` method of S_LibrarySession.

(Published)

Field Summary
`static java.lang.String` | `DBMS_AUDIT_TABLENAME_PREFIX` The database object prefix for audit tablenames.
`protected static java.lang.String` | `DBMS_BASESECUREVIEWNAME_PREFIX` The database object prefix for base-secure views.
`protected static java.lang.String` | `DBMS_BASEVIEWNAME_PREFIX` The database object prefix for the base view (admin mode access against PublicObjects with no delete filtering).
`protected static java.lang.String` | `DBMS_INDEXNAME_PREFIX` The database object prefix for indexes.
`protected static java.lang.String` | `DBMS_SECUREVIEWNAME_PREFIX` The database object prefix for secure views.
`static java.lang.String` | `DBMS_TABLENAME_PREFIX` The database object prefix for tablenames.
`protected static java.lang.String` | `DBMS_UNDELETED_SECUREVIEWNAME_PREFIX` The database object prefix for secure undeleted-only views.
`protected static java.lang.String` | `DBMS_UNDELETED_VIEWNAME_PREFIX` The database object prefix for undeleted-only views.
`static java.lang.String` | `DBMS_VIEWNAME_PREFIX` The database object prefix for views.
`protected static java.lang.String` | `REPOS_PARAM_AUDITING_ENABLED_KEY` The repository parameter key that indicates whether auditing is enabled.
`static java.lang.String` | `SERVICE_REGISTRY_ACL_INDEX_SERVICE` The AccessControlListIndexService.
`static java.lang.String` | `SERVICE_REGISTRY_ACL_PROXY_SERVICE` The AccessControlListProxyService.
`static java.lang.String` | `SERVICE_REGISTRY_ACL_RESOLVER_SERVICE` The AccessControlListDiscoverAccessService.
`static java.lang.String` | `SERVICE_REGISTRY_DIRECTORY_SERVICE` The DirectoryService.
`static java.lang.String` | `SERVICE_REGISTRY_EVENT_EXCHANGER` The S_LibraryServiceEventExchanger.
`static java.lang.String` | `SERVICE_REGISTRY_FOLDER_INDEX_SERVICE` The FolderIndexService.
`static java.lang.String` | `SERVICE_REGISTRY_GROUP_INDEX_SERVICE` The GroupIndexService.
`static java.lang.String` | `SERVICE_REGISTRY_READONLY_CONNECTION_POOL` The readonly ConnectionPool.
`static java.lang.String` | `SERVICE_REGISTRY_WRITEABLE_CONNECTION_POOL` The writeable ConnectionPool.

Fields inherited from interface oracle.ifs.beans.resources.LibraryConstants
`AUDIT_EVENT_COLUMN_APPLICATIONCONTEXT, AUDIT_EVENT_COLUMN_APPLICATIONUSER, AUDIT_EVENT_COLUMN_AUXILIARYNUMBER, AUDIT_EVENT_COLUMN_AUXILIARYSTRING, AUDIT_EVENT_COLUMN_CREATEDATE, AUDIT_EVENT_COLUMN_CREATORID, AUDIT_EVENT_COLUMN_DOMAINID, AUDIT_EVENT_COLUMN_ID, AUDIT_EVENT_COLUMN_OPERATIONSUCCEEDED, AUDIT_EVENT_COLUMN_OPERATIONTYPE, AUDIT_EVENT_COLUMN_TARGETOBJECTID, AUDIT_SPECIFICATION_CUSTOM, AUDIT_SPECIFICATION_GLOBAL, AUDIT_SPECIFICATION_OBJECT, AUDIT_SUCCESS_MODE_FAILURE_ONLY, AUDIT_SUCCESS_MODE_NONE, AUDIT_SUCCESS_MODE_SUCCESS_ONLY, AUDIT_SUCCESS_MODE_SUCCESS_OR_FAILURE, CAPABILITY_ADDITEM, CAPABILITY_ADDVERSION, CAPABILITY_ADMINISTER_CATEGORY, CAPABILITY_ADMINISTER_CONFIGURATION, CAPABILITY_ADMINISTER_CONTAINER, CAPABILITY_ADMINISTER_DOMAIN, CAPABILITY_ADMINISTER_LOCK, CAPABILITY_ADMINISTER_QUOTA, CAPABILITY_ADMINISTER_RECORD, CAPABILITY_ADMINISTER_ROLE, CAPABILITY_ADMINISTER_SECURITY, CAPABILITY_ADMINISTER_USER, CAPABILITY_ADMINISTER_WORKSPACE, CAPABILITY_COPY, CAPABILITY_CREATECONTAINER, CAPABILITY_CREATEFOLDER, CAPABILITY_CREATEWORKSPACE, CAPABILITY_DELETE, CAPABILITY_DISCOVER, CAPABILITY_GET_CONTENT, CAPABILITY_GETAUDITHISTORY, CAPABILITY_GETMETADATA, CAPABILITY_GETRELATION, CAPABILITY_LOCK, CAPABILITY_MOVE, CAPABILITY_SET_ATTR, CAPABILITY_SET_CONTENT, CAPABILITY_SETMETADATA, CAPABILITY_SETRELATION, EXCEPTION_INFO_AGGREGATE_ENTRIES, EXCEPTION_INFO_CONFLICTING_OBJECT_ID, EXCEPTION_INFO_DESCRIPTION_MAP, EXCEPTION_INFO_LIMIT, EXCEPTION_INFO_OBJECT_ID, EXCEPTION_INFO_PARAMETER_NAME, IFS_DOMAIN_ACCESSCONTROLLIST_BYPASSNAMEUNIQUENESSCHECK, IFS_DOMAIN_ACCESSCONTROLLIST_COMPOSITEACLSUPPORTED, IFS_DOMAIN_ACLINDEX_EVENTTARGET, IFS_DOMAIN_APPLICATION_INITIALIZERCLASSNAME, IFS_DOMAIN_AUDIT_AUDITINGENABLED, IFS_DOMAIN_AUDITING_GLOBALAUDITEVENTEXPIRATIONPERIOD, IFS_DOMAIN_AUDITING_GLOBALAUDITTYPELIST, IFS_DOMAIN_AUDITRULEEVALUATORCLASS, IFS_DOMAIN_CONFIGURATIONCATEGORYDESCRIPTORMAPCLASSNAME, IFS_DOMAIN_CREDENTIALMANAGER_ANONYMOUSUSER, IFS_DOMAIN_CREDENTIALMANAGER_ANONYMOUSUSERNAME, IFS_DOMAIN_CREDENTIALMANAGER_AUTOUSERPROVISIONINGENABLED, IFS_DOMAIN_CREDENTIALMANAGER_IDM, IFS_DOMAIN_CREDENTIALMANAGER_IDM_COUNT_LIMIT, IFS_DOMAIN_CREDENTIALMANAGER_IDM_EXTERNALLY_SUPPORTED_ATTRIBUTES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_DIRECTORY_VENDOR, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_GROUP_MEMBER_ATTRIBUTES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_GROUP_NAME_ATTRIBUTE, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_GROUP_OBJECT_CLASSES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_GROUP_SEARCHBASES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_HOST, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_PORT, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_SSL_ENABLED, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_USER_NAME_ATTRIBUTE, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_USER_OBJECT_CLASSES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_USER_SEARCHBASES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_PAGE_SIZE, IFS_DOMAIN_CREDENTIALMANAGER_IDM_SECURITY_PROVIDER_TYPE, IFS_DOMAIN_CREDENTIALMANAGER_IDM_TIME_LIMIT, IFS_DOMAIN_CREDENTIALMANAGER_IDM_XML_FILE_PATH, IFS_DOMAIN_CREDENTIALMANAGER_IDM_XML_REALM, IFS_DOMAIN_CREDENTIALMANAGER_IDMENABLED, IFS_DOMAIN_DEFAULT_TIMEZONE_STRING, IFS_DOMAIN_DEFINITIONCLONINGREQUIRED, IFS_DOMAIN_DIRECTORYGROUP_BYPASSNAMEUNIQUENESSCHECK, IFS_DOMAIN_DOCUMENT_DEFINITIONOBJECTEXPIRATIONPERIOD, IFS_DOMAIN_FDKCONFIGURATIONCLASS, IFS_DOMAIN_FOLDERINDEX_EVENTTARGET, IFS_DOMAIN_LIBRARYOBJECT_AUDITSPECIFICATION_GLOBALAUDITHISTORY, IFS_DOMAIN_LIBRARYOBJECT_AUDITSPECIFICATION_OBJECTAUDITHISTORY, IFS_DOMAIN_LIBRARYOBJECT_CLASSACCESSCONTROLLIST_CLASSPRIVATE, IFS_DOMAIN_LIBRARYOBJECT_CLASSACCESSCONTROLLIST_CLASSPUBLIC, IFS_DOMAIN_LIBRARYOBJECT_CLASSACCESSCONTROLLIST_CLASSRESTRICTCREATION, IFS_DOMAIN_LIBRARYOBJECT_MEDIA_DEFAULTCONTENTMEDIA, IFS_DOMAIN_LIBRARYOBJECT_MEDIA_NONCONTENTMEDIA, IFS_DOMAIN_LIBRARYOBJECT_NODECONFIGURATION_DEFAULTNODECONFIGURATION, IFS_DOMAIN_LIBRARYOBJECT_SERVICECONFIGURATION_DEFAULTSERVICECONFIGURATION, IFS_DOMAIN_LIBRARYOBJECT_STORAGEGROUP_DEFAULTSTORAGEGROUP, IFS_DOMAIN_LIBRARYOBJECT_SYSTEMACCESSCONTROLLIST_PRIVATE, IFS_DOMAIN_LIBRARYOBJECT_SYSTEMACCESSCONTROLLIST_PUBLIC, IFS_DOMAIN_LIBRARYOBJECT_SYSTEMACCESSCONTROLLIST_PUBLISHED, IFS_DOMAIN_LIBRARYOBJECT_SYSTEMLOCKOBJECT_SYSTEMHARDLOCK, IFS_DOMAIN_LIBRARYOBJECT_SYSTEMLOCKOBJECT_SYSTEMSOFTLOCK, IFS_DOMAIN_LOCALIZER_DEFAULTEXTENDEDRESOURCEBUNDLENAMES, IFS_DOMAIN_LOCKOBJECT_ENABLED, IFS_DOMAIN_LOOKUP_CLUSTERING_PROPERTIES, IFS_DOMAIN_LOOKUP_CUSTOMLOCKTYPES, IFS_DOMAIN_LOOKUP_ORACLELOCKTYPES, IFS_DOMAIN_LOOKUP_SORTOBJECTCOLLECTION, IFS_DOMAIN_OIDCREDENTIALMANAGERAGENT_SUBSCRIBERS, IFS_DOMAIN_OPERATIONACTIONSPECIFICATION_GLOBALLIST, IFS_DOMAIN_PROPERTYBUNDLE_NAME, IFS_DOMAIN_PROTOCOLS_DAV_COPYMOVETHROUGHFOLDERLINKENABLED, IFS_DOMAIN_PROTOCOLS_DAV_NULLRESOURCELOCKEXPIRATIONPERIOD, IFS_DOMAIN_PROTOCOLS_DAV_USERAGENTS, IFS_DOMAIN_RANDOMACCESSOR_EXPIRATIONPERIOD, IFS_DOMAIN_SEARCH_ATTEMPTCONTEXTSEARCHREWRITE, IFS_DOMAIN_SECURITY_SYNCHRONOUSSECURITYREFRESHENABLED, IFS_DOMAIN_SHAREDSTATEFACTORY, IFS_DOMAIN_UPGRADEINPROGRESS, IFS_DOMAIN_WORKFLOW_BPEL_CREATIONENABLED, IFS_DOMAIN_WORKFLOW_BPEL_WORKLISTURL, IFS_DOMAIN_WORKFLOW_ENABLED, IFS_DOMAIN_WORKFLOW_SCHEMANAME, IFS_DOMAIN_WS_CLEARTEXTAUTHENTICATIONREQUIRESHTTPS, IFS_HANDLER_PROPERTY_BASETIMEOFDAY, IFS_HANDLER_PROPERTY_NOTIFIEDONEVENT, IFS_HANDLER_PROPERTY_TIMERPERIOD, IFS_NODE_DISABLEDINHERITEDPROPERTYNAMES, IFS_NODE_DISABLEDINHERITEDSERVERNAMES, IFS_NODE_ENABLEDINHERITEDPROPERTYNAMES, IFS_NODE_ENABLEDINHERITEDSERVERNAMES, IFS_ORACLELOCKTYPE_KEY_CHECKOUT, IFS_ORACLELOCKTYPE_KEY_DAV, IFS_ORACLELOCKTYPE_KEY_FINALIZED, IFS_ORACLELOCKTYPE_KEY_FREEZE, IFS_ORACLELOCKTYPE_KEY_HASRECORD, IFS_ORACLELOCKTYPE_KEY_LIFECYCLE, IFS_ORACLELOCKTYPE_KEY_MANUAL, IFS_ORACLELOCKTYPE_KEY_NAMEDFREEZE, IFS_ORACLELOCKTYPE_KEY_RECORD, IFS_ORACLELOCKTYPE_KEY_RETENTION, IFS_ORACLELOCKTYPE_KEY_WORKFLOW, IFS_SERVICE_ACLCACHE_EMERGENCYTRIGGER, IFS_SERVICE_ACLCACHE_NORMALTRIGGER, IFS_SERVICE_ACLCACHE_PURGETARGET, IFS_SERVICE_ACLCACHE_SIZE, IFS_SERVICE_ACLCACHE_URGENTTRIGGER, IFS_SERVICE_AUDITCERTIFICATECACHE_PURGETARGET, IFS_SERVICE_AUDITINGENABLED, IFS_SERVICE_AUDITSTRINGCACHE_PURGETARGET, IFS_SERVICE_AURORASERVICE, IFS_SERVICE_CASESENSITIVEAUTHENTICATION, IFS_SERVICE_CHECKFORORPHANSESSIONSPERIOD, IFS_SERVICE_CONNECTIONPOOL_READONLY_MAXIMUMSIZE, IFS_SERVICE_CONNECTIONPOOL_READONLY_MAXIMUMSIZETIMEOUT, IFS_SERVICE_CONNECTIONPOOL_READONLY_MINIMUMSIZE, IFS_SERVICE_CONNECTIONPOOL_READONLY_STATEMENTCACHESIZETRIGGER, IFS_SERVICE_CONNECTIONPOOL_READONLY_STATEMENTCACHETARGET, IFS_SERVICE_CONNECTIONPOOL_READONLY_STATEMENTRESETLIMIT, IFS_SERVICE_CONNECTIONPOOL_READONLY_TARGETSIZE, IFS_SERVICE_CONNECTIONPOOL_READONLY_TARGETSIZETIMEOUT, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_MAXIMUMSIZE, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_MAXIMUMSIZETIMEOUT, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_MINIMUMSIZE, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_STATEMENTCACHESIZETRIGGER, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_STATEMENTCACHETARGET, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_STATEMENTRESETLIMIT, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_TARGETSIZE, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_TARGETSIZETIMEOUT, IFS_SERVICE_CONTENTBUFFERSIZE, IFS_SERVICE_CREDENTIALMANAGER, IFS_SERVICE_CREDENTIALMANAGER_CREDENTIALNAMETOKENIZER, IFS_SERVICE_CREDENTIALMANAGER_NAMES, IFS_SERVICE_DATACACHE_EMERGENCYTRIGGER, IFS_SERVICE_DATACACHE_NORMALTRIGGER, IFS_SERVICE_DATACACHE_PURGETARGET, IFS_SERVICE_DATACACHE_SIZE, IFS_SERVICE_DATACACHE_URGENTTRIGGER, IFS_SERVICE_DEFAULTCHARACTERSET, IFS_SERVICE_DEFAULTLANGUAGE, IFS_SERVICE_EVENTEXCHANGER, IFS_SERVICE_EVENTSTATEMENTRESETLIMIT, IFS_SERVICE_JDBC_DEFAULTROWPREFETCH, IFS_SERVICE_JDBC_DRIVER, IFS_SERVICE_JDBC_DRIVERTYPE, IFS_SERVICE_JDBC_TRACINGENABLED, IFS_SERVICE_LOCKTIMEOUTPERIOD, IFS_SERVICE_MAXIMUMCONCURRENTSESSIONS, IFS_SERVICE_MAXIMUMPOOLEDCONTENTBUFFERSPERSESSION, IFS_SERVICE_ORPHANSESSIONTIMEOUTPERIOD, IFS_SERVICE_POLLFOREVENTSFROMOTHERSERVICESPERIOD, IFS_SERVICE_QUOTACHECKFREQUENCYINBYTES, IFS_SERVICE_SERVICEKEEPALIVEEVENTPERIOD, IFS_SERVICE_SESSION_BEANSOBJECTCACHE_SIZE, IFS_SERVICE_SESSION_BEANSSESSION, IFS_SERVICE_SESSION_DATACACHE_EMERGENCYTRIGGER, IFS_SERVICE_SESSION_DATACACHE_NORMALTRIGGER, IFS_SERVICE_SESSION_DATACACHE_PURGETARGET, IFS_SERVICE_SESSION_DATACACHE_SIZE, IFS_SERVICE_SESSION_DATACACHE_URGENTTRIGGER, IFS_SERVICE_SESSION_DEFAULTSEARCHTIMEOUTPERIOD, IFS_SERVICE_SESSION_EVENTPOLLER, IFS_SERVICE_SESSION_EVENTPOLLERPERIOD, IFS_SERVICE_SESSION_FOLDERITEM_CACHING_ENABLED, IFS_SERVICE_SESSION_FOLDERPATHCACHE_ENABLED, IFS_SERVICE_SESSION_FOLDERPATHCACHE_NORMALTRIGGER, IFS_SERVICE_SESSION_FOLDERPATHCACHE_PURGETARGET, IFS_SERVICE_SESSION_FOLDERPATHCACHE_SIZE, IFS_SERVICE_SESSION_FOLDERPATHCACHE_URGENTTRIGGER, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_EMERGENCYTRIGGER, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_ISUNBOUNDED, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_NORMALTRIGGER, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_PURGETARGET, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_SIZE, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_URGENTTRIGGER, IFS_SERVICE_SESSION_SERVERSESSION, IFS_SERVICE_SESSION_TRANSACTIONSTACKSIZE, IFS_SERVICE_SESSIONOPERATIONTIMEOUTPERIOD, IFS_SERVICE_TRACING_BEANSSESSIONTRACETYPE, IFS_SERVICE_TRACING_CHANNELCOUNT, IFS_SERVICE_TRACING_CHANNELLEVEL, IFS_SERVICE_TRACING_DEFAULTTRACELEVEL, IFS_SERVICE_TRACING_SERVERSESSIONTRACETYPE, IFS_SERVICE_TRACING_SERVICETRACETYPE, IFS_SERVICE_TRANSPORTBATCHSIZE, IFS_SERVICE_TRANSPORTEVENTSTOOTHERSERVICESPERIOD, IFS_SESSIONSTATE_APPLICATION_SESSIONID, IFS_SESSIONSTATE_AUDIT_DOMAIN_DEFAULT, IFS_SESSIONSTATE_OPERATIONS_COPYTABLE, IFS_SESSIONSTATE_OPERATIONS_FREETABLE, IFS_SESSIONSTATE_OPERATIONS_UPDATETABLE, LOCKTYPE_CHECKOUT, LOCKTYPE_CUSTOM, LOCKTYPE_DAV, LOCKTYPE_FAMILYHASRECORD, LOCKTYPE_FINALIZED, LOCKTYPE_FREEZE, LOCKTYPE_HAS_RECORD, LOCKTYPE_LIFECYCLE, LOCKTYPE_MANUAL, LOCKTYPE_NAMEDFREEZE, LOCKTYPE_RECORD, LOCKTYPE_RETENTION, LOCKTYPE_WORKFLOW, PUBLIC_SESSIONSTATE_APPLICATION_CONTEXT, PUBLIC_SESSIONSTATE_APPLICATION_USERIDENTIFER, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_CHECKOUT, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_DAV, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_FINALIZED, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_FREEZE, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_HASRECORD, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_LIFECYCLE, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_MANUAL, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_NAMEDFREEZE, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_RECORD, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_RETENTION, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_WORKFLOW, SYSTEMLOCK_NAME_FINALIZED, SYSTEMLOCK_NAME_FREEZE, SYSTEMLOCK_NAME_HAS_RECORD, SYSTEMLOCK_NAME_LIFECYCLE, SYSTEMLOCK_NAME_RECORD, SYSTEMLOCK_NAME_RETENTION`

Constructor Summary
`protected` | `S_LibraryService()` Constructs a S_LibraryService.

Method Summary
`protected void` | `addSession(S_LibrarySession session)` Adds the specified S_LibrarySession to the set of sessions managed by this S_LibraryService.
`protected void` | `checkSchemaPassword(java.lang.String password)` Checks if the supplied value is the schema password.
`protected void` | `cleanupDeadServices(S_LibrarySession session, long serviceTimeoutPeriod)` Cleans up S_LibraryServices that have abnormally terminated.
`static void` | `closeResultSet(java.sql.ResultSet rset)` Try our best to close a resultSet; no exceptions thrown
`static void` | `closeStatement(java.sql.Statement stmt)` Try our best to close a Statement; no exceptions thrown
`static void` | `closeStatement(StatementWrapper stmt)` Try our best to close a wrapped Statement; no exceptions thrown
`S_LibrarySessionInterface` | `connect(Credential credential, ConnectOptions options)` Creates a new session on this S_LibraryService.
`protected S_LibrarySession` | `constructSession()` Dynamically constructs an unauthenticated S_LibrarySession.
`static void` | `deleteRepositoryParameter(java.sql.Connection conn, java.lang.String name)` Deletes the specified repository parameter.
`void` | `deregisterServiceEventHandler(IfsEventHandler handler)` De-register a Service event handler.
`protected void` | `disconnectIdleSessions(long currentTime)` Disconnects S_LibrarySessions that have been idle for longer than the value of the `SessionTimeoutPeriod` parameter in the service properties file.
`void` | `disconnectSession(java.lang.Long sessionId)` Disconnects the specified session.
`void` | `dispose()` Disposes this iFS service.
`void` | `dispose(javax.sql.DataSource dataSource)` Disposes this iFS service.
`void` | `dispose(java.lang.String schemaPassword)` Disposes this iFS service.
`void` | `dispose(SystemUserCredential cred)` Disposes this service.
`void` | `disposeFolderIndexService()` Dispose the FolderIndexService on-the-fly.
`protected void` | `disposeSubServiceIgnoreError(SubService sub)` Disposes the specified subservice, consuming any thrown IfsException.
`void` | `establishFolderIndexService()` Establish a FolderIndexService on-the-fly.
`static S_LibraryService` | `findService(java.lang.String serviceName)` Finds an existing iFS service with the specified name.
`protected SubService` | `findSubService(java.lang.String name)` Gets a subservice by name.
`AccessControlListDiscoverAccessService` | `getAccessControlListDiscoverAccessService()` Gets the AccessControlListProxyService for this S_LibraryService.
`AccessControlListIndexService` | `getAccessControlListIndexService()` Gets the AccessControlListIndexService for this S_LibraryService.
`AccessControlListProxyService` | `getAccessControlListProxyService()` Gets the AccessControlListProxyService for this S_LibraryService.
`protected S_LibrarySession[]` | `getAllSessions()` Gets all connected sessions
`protected SubService[]` | `getAllSubServices()` Gets all registered SubServices.
`long` | `getAttributesRsn()` Gets the resolution sequence number at which an attribute was last added or removed.
`protected BoundedCache` | `getAuditCertificateCache()` Gets the AuditCertificate cache.
`BoundedCacheConfiguration` | `getAuditCertificateCacheConfiguration()` Gets the configuration parameters of the AuditCertificate cache.
`CachePerformance` | `getAuditCertificateCachePerformance()` Gets the performance information for the AuditCertificate cache.
`protected BoundedCache` | `getAuditInlineStringCache()` Gets the Audit cache for inline strings.
`protected BoundedCache` | `getAuditInlineStringReferenceCache()` Gets the Audit cache for references to inline strings.
`protected java.util.HashMap` | `getBootstrapClassPolicyActionContexts()` Gets the "policy bootstrap" PolicyActionContexts.
`java.lang.Long` | `getClockOffset()` Gets the clock offset, representing the number of milliseconds the DBMS clock is ahead of this mid tier.
`protected BoundedCache` | `getCommittedLibraryObjectDataCache()` Gets the committed S_LibraryObjectData cache.
`BoundedCacheConfiguration` | `getCommittedLibraryObjectDataCacheConfiguration()` Gets the configuration parameters of the committed S_LibraryObjectData cache.
`CachePerformance` | `getCommittedLibraryObjectDataCachePerformance()` Gets the performance information for the committed S_LibraryObjectData cache.
`protected BoundedCache` | `getCommittedResolvedAclCache()` Gets the committed resolved ACL cache.
`BoundedCacheConfiguration` | `getCommittedResolvedAclCacheConfiguration()` Gets the configuration parameters of the committed Resolved Acl cache.
`CachePerformance` | `getCommittedResolvedAclCachePerformance()` Gets the performance information for the committed Resolved Acl cache.
`java.util.Hashtable` | `getConfigurationProperties()` Gets the configuration properties of this service.
`CredentialNameTokenizer` | `getCredentialNameTokenizer()` Gets the CredentialNameTokenizer for this S_LibraryService.
`protected static long` | `getCurrentTime()` Returns the current time as a long, appropriate for storing in the database.
`static long` | `getDatabaseVersionNumber(java.sql.Connection conn)` Gets the version of the database as a long
`static java.lang.String` | `getDatabaseVersionString(java.sql.Connection conn)` Gets the version of the Database as a string.
`DirectoryGroupIndexService` | `getDirectoryGroupIndexService()` Gets the DirectoryGroupIndexService for this S_LibraryService.
`DirectoryService` | `getDirectoryService()` Gets the DirectoryService of this S_LibraryService.
`long` | `getEffectiveSchemaVersionNumber()` Gets the effective schema version as a long.
`java.lang.String` | `getEffectiveSchemaVersionString()` Gets the effective schema version as a string.
`static java.lang.String` | `getEncryptedRepositoryParameter(java.sql.Connection conn, java.lang.String name)` Gets the value of the specified repository parameter.
`protected oracle.ifs.server.S_LibraryServiceEventExchanger` | `getEventExchanger()` Returns the S_LibraryServiceEventExchanger of this S_LibraryService.
`FolderIndexService` | `getFolderIndexService()` Gets the FolderIndexService for this S_LibraryService.
`GssApiCredential` | `getGssApiCredential(byte[] inputTicket, java.util.Hashtable parameters)` Gets a new GssApiCredential using the supplied ticket.
`protected java.lang.Long` | `getGuestUserId(S_LibrarySession session)` Gets the ID of the guest user.
`java.lang.Long` | `getId()` Gets the id of this service.
`Localizer` | `getLocalizer()` Gets the Localizer of this S_LibraryService.
`protected long` | `getLockrowsTimeoutPeriod()` Gets the timeout period to use for timeout of the lockrows() operation.
`int` | `getMaximumConcurrentSessions()` Gets the maximum number of concurrent sessions for this service.
`int` | `getMaximumConcurrentSessionsPerUser()` Gets the maximum number of concurrent sessions per user for this service.
`java.lang.String` | `getName()` Gets the name of this service.
`java.lang.String` | `getNodeName()` Gets the name of the node that started this service.
`protected PolicyAction` | `getPolicyAction(java.lang.String className)` Finds a PolicyAction specified by fully-qualified classname.
`protected ConnectionPool` | `getReadonlyConnectionPool()` Gets the readonly connection pool for this S_LibraryService.
`ConnectionPoolConfiguration` | `getReadonlyConnectionPoolConfiguration()` Gets the configuration parameters of the readonly ConnectionPool.
`ConnectionPoolPerformance` | `getReadonlyConnectionPoolPerformance()` Gets the performance information for the readonly ConnectionPool.
`static java.lang.String` | `getRepositoryParameter(java.sql.Connection conn, java.lang.String name)` Gets the value of the specified repository parameter.
`protected static java.lang.String` | `getRepositoryParameter(java.sql.Connection conn, java.lang.String name, boolean shouldLock)` Gets the value of the specified repository parameter, acquiring a row-level lock if specified.
`protected java.lang.String` | `getRepositoryParameter(java.lang.String name)` Gets the value of the specified repository parameter.
`protected java.lang.String[]` | `getRepositoryParameterNames(java.sql.Connection conn, java.lang.String prefix)` Gets the repository parameter names that start with the specified prefix.
`java.lang.String` | `getResourceString(java.lang.String key)` Gets the resource string for the specified key.
`java.lang.String` | `getResourceString(java.lang.String key, java.lang.Object[] params)` Gets the resource string for the specified key, and substitutes the specified parameters into that resource string.
`long` | `getRsn()` Gets the last-generated resolution sequence number.
`java.lang.String` | `getSchemaName()` Returns the name of the schema used by this service.
`long` | `getSchemaVersionNumber()` Gets the schema version as a long.
`java.lang.String` | `getSchemaVersionString()` Gets the schema version as a string.
`AttributeValue` | `getServiceConfigurationProperty(java.lang.String name)` Gets the specified service configuration property.
`boolean` | `getServiceConfigurationProperty(java.lang.String name, boolean defaultValue)` Gets the value of the specified service configuration property, as a boolean.
`double` | `getServiceConfigurationProperty(java.lang.String name, double defaultValue)` Gets the value of the specified service configuration property, as a double.
`int` | `getServiceConfigurationProperty(java.lang.String name, int defaultValue)` Gets the value of the specified service configuration property, as an integer.
`java.lang.String` | `getServiceConfigurationProperty(java.lang.String name, java.lang.String defaultValue)` Gets the value of the specified service configuration property, as a string.
`static S_LibraryService[]` | `getServices()` Gets the existing iFS services in this VM.
`java.lang.reflect.Constructor` | `getSessionConstructor()` Gets the S_LibrarySession constructor.
`protected int` | `getSessionCount()` Gets the number of sessions currently connected to this service.
`protected java.lang.Object` | `getSystemUserToken(S_LibrarySession session)` Gets the system token that can be used to efficiently clone system sessions.
`TokenCredential` | `getTokenCredential(java.lang.String token, java.util.Hashtable parameters, boolean consume)` Gets the previously-created TokenCredential for the specified token.
`TraceLogger` | `getTraceLogger()` Gets the TraceLogger of this S_LibraryService.
`static long` | `getVersionNumber()` Gets the version of this S_LibraryService as a long.
`static java.lang.String` | `getVersionString()` Gets the version of this S_LibraryService as a string.
`protected ConnectionPool` | `getWriteableConnectionPool()` Gets the writeable connection pool for this S_LibraryService.
`ConnectionPoolConfiguration` | `getWriteableConnectionPoolConfiguration()` Gets the configuration parameters of the writeable ConnectionPool.
`ConnectionPoolPerformance` | `getWriteableConnectionPoolPerformance()` Gets the performance information for the writeable ConnectionPool.
`void` | `handleEvent(IfsEvent event)` Handles the specified event.
`void` | `incrementAttributesRsn()` Increments the resolution sequence number at which an attribute was last added or removed.
`protected void` | `initialize(java.lang.String name, java.lang.String nodeName, AttributeValue[] serviceConfiguration, javax.sql.DataSource dataSource)` Initializes a S_LibraryService.
`void` | `invalidateTokenCredential(java.lang.String token, java.util.Hashtable parameters)` Invalidates the previously-created TokenCredential for the specified token.
`boolean` | `isAcceptingNewSessions()` Gets whether this service currently accepts new sessions, subject to its maximum number of concurrent sessions.
`boolean` | `isAclResolutionSynchronous()` Returns the ACL resolution mode.
`protected boolean` | `isAuditingEnabled()` Returns indication as to whether auditing is enabled.
`boolean` | `isAuroraService()` Gets whether this S_LibraryService is running in Aurora.
`boolean` | `isDisposedOnLastDisconnect()` Gets whether this service will be automatically disposed when its last session is disconnected.
`protected boolean` | `isLykeEnabled()` Gets whether there is a ctxsubstr ("LYKE") index on the NAME attribute of PublicObject.
`protected boolean` | `isPartitioningEnabled(S_LibrarySession session)` checks whether or not partitioning is being used in this instance.
`static boolean` | `isServiceStarted(java.lang.String serviceName)` Determines whether there exists an iFS service with the specified name.
`boolean` | `isTraced(int channel, int level)` Gets whether tracing is enabled for the specified channel and level.
`static java.lang.String` | `lockRepositoryParameter(java.sql.Connection conn, java.lang.String name)` Gets the value of the specified repository parameter, acquiring a row-level lock on it.
`protected static ContentStreamSerializer` | `newContentStreamSerializer()` Constructs and returns a ContentStreamSerializer appropriate to the runtime process model.
`long` | `nextRsn()` Gets the next resolution sequence number.
`protected void` | `postEvent(IfsEvent event)` Posts the specified event.
`protected void` | `processEvent(IfsEvent event)` Processes the specified event.
`protected void` | `putPolicyAction(java.lang.String className, PolicyAction pa)` Caches a PolicyAction specified by fully-qualified classname.
`void` | `registerServiceEventHandler(IfsEventHandler handler)` Register a Service event handler.
`protected void` | `registerSubService(java.lang.String name, SubService sub)` Registers a subservice.
`protected void` | `removePolicyAction(java.lang.String className)` Removes a PolicyAction specified by fully-qualified classname.
`protected void` | `removeSession(S_LibrarySession session)` Removes the specified S_LibrarySession from the set of sessions managed by this S_LibraryService.
`void` | `resetAuditCertificateCachePerformance()` Resets the performance information for the AuditCertificate cache.
`protected void` | `resetCachedStatements()` Resets the cached statements in the connection pools.
`void` | `resetCommittedLibraryObjectDataCachePerformance()` Resets the performance information for the committed S_LibraryObjectData cache.
`void` | `resetCommittedResolvedAclCachePerformance()` Resets the performance information for the committed Resolved Acl cache.
`protected void` | `resetConnectionPools()` Resets the connection pools.
`protected void` | `resetConnectionPools(boolean minimizePools)` Resets the connection pools.
`void` | `resetReadonlyConnectionPoolStatistics()` Resets the performance statistics of the readonly ConnectionPool.
`void` | `resetWriteableConnectionPoolStatistics()` Resets the performance statistics of the writeable ConnectionPool.
`protected void` | `sendServiceKeepAliveEvent(long currentTime)` Periodically sends a keep-alive IfsEvent to other S_LibraryServices.
`void` | `setAcceptingNewSessions(boolean accepting)` Sets whether this service currently accepts new sessions, subject to its maximum number of concurrent sessions.
`void` | `setAuditCertificateCacheConfiguration(BoundedCacheConfiguration configuration)` Alters the configuration of the AuditCertificate cache.
`void` | `setBootstrapClassPolicyActionContexts(java.util.HashMap pacs, java.lang.String schemaPassword)` Puts the service in "policy bootstrap" mode.
`void` | `setCommittedLibraryObjectDataCacheConfiguration(BoundedCacheConfiguration configuration)` Alters the configuration of the committed S_LibraryObjectData cache.
`void` | `setCommittedResolvedAclCacheConfiguration(BoundedCacheConfiguration configuration)` Alters the configuration of the committed Resolved Acl cache.
`void` | `setDisposedOnLastDisconnect(boolean dispose)` Sets whether this service will be automatically disposed when its last session is disconnected.
`static void` | `setEncryptedRepositoryParameter(java.sql.Connection conn, java.lang.String name, java.lang.String value)` Sets the value of the specified repository parameter.
`void` | `setMaximumConcurrentSessions(int count)` Sets the maximum number of concurrent sessions for this service.
`void` | `setMaximumConcurrentSessionsPerUser(int count)` Sets the maximum number of concurrent sessions per user for this service.
`void` | `setReadonlyConnectionPoolConfiguration(ConnectionPoolConfiguration configuration)` Alters the configuration of the readonly ConnectionPool.
`static void` | `setRepositoryParameter(java.sql.Connection conn, java.lang.String name, java.lang.String value)` Sets the value of the specified repository parameter.
`void` | `setWriteableConnectionPoolConfiguration(ConnectionPoolConfiguration configuration)` Alters the configuration of the writeable ConnectionPool.
`static S_LibraryService` | `startService(java.lang.String serviceName, java.lang.String nodeName, AttributeValue[] serviceConfig, javax.sql.DataSource dataSource)` Starts a new iFS service with the specified name.
`protected static void` | `throwUnexpectedException(java.lang.String methodname, java.lang.Exception e)` Throws an unexpected exception.
`void` | `trace(int channel, int level, java.lang.String payload)` Issues a trace request to the trace logger.
`protected SubService` | `unregisterSubService(java.lang.String name)` Unregisters a subservice.
`protected void` | `verifyMaximumConcurrentSessionsPerUser(S_LibrarySession session, java.lang.Long userId)` Verifies the just-connected session didn't blow out the maximum number of concurrent sessions per user for this service.
`protected void` | `verifySchemaVersion()` Checks the validity of the schema version number.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DBMS_TABLENAME_PREFIX

    public static java.lang.String DBMS_TABLENAME_PREFIX

  Description copied from class: `S_LibraryService`
  The database object prefix for tablenames.

  (Published)

### DBMS_VIEWNAME_PREFIX

    public static java.lang.String DBMS_VIEWNAME_PREFIX

  Description copied from class: `S_LibraryService`
  The database object prefix for views.

  (Published)

### DBMS_AUDIT_TABLENAME_PREFIX

    public static java.lang.String DBMS_AUDIT_TABLENAME_PREFIX

  Description copied from class: `S_LibraryService`
  The database object prefix for audit tablenames.

  (Published)

### DBMS_BASEVIEWNAME_PREFIX

    protected static java.lang.String DBMS_BASEVIEWNAME_PREFIX

  Description copied from class: `S_LibraryService`
  The database object prefix for the base view (admin mode access against PublicObjects with no delete filtering).

  (Unpublished)

### DBMS_UNDELETED_VIEWNAME_PREFIX

    protected static java.lang.String DBMS_UNDELETED_VIEWNAME_PREFIX

  Description copied from class: `S_LibraryService`
  The database object prefix for undeleted-only views.

  (Unpublished)

### DBMS_BASESECUREVIEWNAME_PREFIX

    protected static java.lang.String DBMS_BASESECUREVIEWNAME_PREFIX

  Description copied from class: `S_LibraryService`
  The database object prefix for base-secure views.

  (Unpublished)

### DBMS_SECUREVIEWNAME_PREFIX

    protected static java.lang.String DBMS_SECUREVIEWNAME_PREFIX

  Description copied from class: `S_LibraryService`
  The database object prefix for secure views.

  (Unpublished)

### DBMS_UNDELETED_SECUREVIEWNAME_PREFIX

    protected static java.lang.String DBMS_UNDELETED_SECUREVIEWNAME_PREFIX

  Description copied from class: `S_LibraryService`
  The database object prefix for secure undeleted-only views.

  (Unpublished)

### DBMS_INDEXNAME_PREFIX

    protected static java.lang.String DBMS_INDEXNAME_PREFIX

  Description copied from class: `S_LibraryService`
  The database object prefix for indexes.

  (Published)

### SERVICE_REGISTRY_DIRECTORY_SERVICE

    public static java.lang.String SERVICE_REGISTRY_DIRECTORY_SERVICE

  Description copied from class: `S_LibraryService`
  The DirectoryService.

  (Published)

### SERVICE_REGISTRY_WRITEABLE_CONNECTION_POOL

    public static java.lang.String SERVICE_REGISTRY_WRITEABLE_CONNECTION_POOL

  Description copied from class: `S_LibraryService`
  The writeable ConnectionPool.

  (Published)

### SERVICE_REGISTRY_READONLY_CONNECTION_POOL

    public static java.lang.String SERVICE_REGISTRY_READONLY_CONNECTION_POOL

  Description copied from class: `S_LibraryService`
  The readonly ConnectionPool.

  (Published)

### SERVICE_REGISTRY_EVENT_EXCHANGER

    public static java.lang.String SERVICE_REGISTRY_EVENT_EXCHANGER

  Description copied from class: `S_LibraryService`
  The S_LibraryServiceEventExchanger.

  (Published)

### SERVICE_REGISTRY_ACL_PROXY_SERVICE

    public static java.lang.String SERVICE_REGISTRY_ACL_PROXY_SERVICE

  Description copied from class: `S_LibraryService`
  The AccessControlListProxyService.

  (Published)

### SERVICE_REGISTRY_ACL_RESOLVER_SERVICE

    public static java.lang.String SERVICE_REGISTRY_ACL_RESOLVER_SERVICE

  Description copied from class: `S_LibraryService`
  The AccessControlListDiscoverAccessService.

  (Published)

### SERVICE_REGISTRY_GROUP_INDEX_SERVICE

    public static java.lang.String SERVICE_REGISTRY_GROUP_INDEX_SERVICE

  Description copied from class: `S_LibraryService`
  The GroupIndexService.

  (Published)

### SERVICE_REGISTRY_ACL_INDEX_SERVICE

    public static java.lang.String SERVICE_REGISTRY_ACL_INDEX_SERVICE

  Description copied from class: `S_LibraryService`
  The AccessControlListIndexService.

  (Published)

### SERVICE_REGISTRY_FOLDER_INDEX_SERVICE

    public static java.lang.String SERVICE_REGISTRY_FOLDER_INDEX_SERVICE

  Description copied from class: `S_LibraryService`
  The FolderIndexService.

  (Published)

### REPOS_PARAM_AUDITING_ENABLED_KEY

    protected static java.lang.String REPOS_PARAM_AUDITING_ENABLED_KEY

  Description copied from class: `S_LibraryService`
  The repository parameter key that indicates whether auditing is enabled.

  (Unpublished)

Constructor Detail

### S_LibraryService

    protected S_LibraryService()

  Constructs a S_LibraryService.

  (Published)

Method Detail

### initialize

    protected void initialize(java.lang.String name,
                              java.lang.String nodeName,
                              AttributeValue[] serviceConfiguration,
                              javax.sql.DataSource dataSource)
                       throws IfsException

  Description copied from class: `S_LibraryService`
  Initializes a S_LibraryService.

  Parameters:
    `name` - the service name
    `nodeName` - the node name
    `serviceConfiguration` - the service configuration properties
    `dataSource` - the data source
  Throws:
    `IfsException` - (IFS-20122) if the operation fails
  (Published)

### getServices

    public static S_LibraryService[] getServices()
                                          throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the existing iFS services in this VM.

  Returns:
    the services, or null if no services are running in this VM
  Throws:
    `IfsException` - if the operation fails
  (Published)

### findService

    public static S_LibraryService findService(java.lang.String serviceName)
                                        throws IfsException

  Description copied from class: `S_LibraryService`
  Finds an existing iFS service with the specified name.

  If there is no service with that name, an exception is thrown.

  Parameters:
    `serviceName` - the name of the service
  Returns:
    the service
  Throws:
    `IfsException` - (IFS-20100) if the operation fails
  (Published)

### isServiceStarted

    public static boolean isServiceStarted(java.lang.String serviceName)
                                    throws IfsException

  Description copied from class: `S_LibraryService`
  Determines whether there exists an iFS service with the specified name.

  Parameters:
    `serviceName` - the name of the service
  Returns:
    whether there is a service with that name
  Throws:
    `IfsException` - (IFS-20101) if the operation fails
  (Published)

### startService

    public static S_LibraryService startService(java.lang.String serviceName,
                                                java.lang.String nodeName,
                                                AttributeValue[] serviceConfig,
                                                javax.sql.DataSource dataSource)
                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Starts a new iFS service with the specified name.

  Throws an exception if there is already a service with that name.

  Parameters:
    `serviceName` - the name of the service
    `nodeName` - the name of the Node that runs this service
    `serviceConfig` - the service configuration properties
    `dataSource` - the database connection
  Returns:
    the new service
  Throws:
    `IfsException` - (IFS-20102) if the operation fails
  (Published)

### dispose

    public void dispose(java.lang.String schemaPassword)
                 throws IfsException

  Description copied from class: `S_LibraryService`
  Disposes this iFS service.

  Parameters:
    `schemaPassword` - the password for the database schema
  Throws:
    `IfsException` - (IFS-20105) if the operation fails
  (Unpublished)

### dispose

    public void dispose(javax.sql.DataSource dataSource)
                 throws IfsException

  Description copied from class: `S_LibraryService`
  Disposes this iFS service.

  Parameters:
    `dataSource` - data source
  Throws:
    `IfsException` - (IFS-20105) if the operation fails
  (Published)

### dispose

    public void dispose(SystemUserCredential cred)
                 throws IfsException

  Description copied from class: `S_LibraryService`
  Disposes this service.

  Parameters:
    `cred` - the password for the database schema
  Throws:
    `IfsException` - (IFS-20105) if the operation fails
  (Published)

### checkSchemaPassword

    protected void checkSchemaPassword(java.lang.String password)
                                throws java.lang.Exception

  Description copied from class: `S_LibraryService`
  Checks if the supplied value is the schema password.

  Parameters:
    `password` - supplied password
  Throws:
    `java.lang.Exception` - if the supplied password is incorrect or if the operation fails

### dispose

    public void dispose()
                 throws IfsException

  Description copied from class: `S_LibraryService`
  Disposes this iFS service.

  Throws:
    `IfsException`
  (Published)

### getId

    public java.lang.Long getId()
                         throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the id of this service.

  Returns:
    the id
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getClockOffset

    public java.lang.Long getClockOffset()
                                  throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the clock offset, representing the number of milliseconds the DBMS clock is ahead of this mid tier.

  Returns:
    the clock offset
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getName

    public java.lang.String getName()
                             throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the name of this service.

  Returns:
    the name of this service
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getNodeName

    public java.lang.String getNodeName()
                                 throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the name of the node that started this service.

  Returns:
    the name of the node that started this service
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getConfigurationProperties

    public java.util.Hashtable getConfigurationProperties()

  Description copied from class: `S_LibraryService`
  Gets the configuration properties of this service.

  Returns:
    the configuration properties
  (Published)

### isAcceptingNewSessions

    public boolean isAcceptingNewSessions()
                                   throws IfsException

  Description copied from class: `S_LibraryService`
  Gets whether this service currently accepts new sessions, subject to its maximum number of concurrent sessions.

  Returns:
    whether the service accepts new sessions
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setAcceptingNewSessions

    public void setAcceptingNewSessions(boolean accepting)
                                 throws IfsException

  Description copied from class: `S_LibraryService`
  Sets whether this service currently accepts new sessions, subject to its maximum number of concurrent sessions.

  Parameters:
    `accepting` - whether the service accepts new sessions
  Throws:
    `IfsException` - if the operation fails
  (Published)

### isDisposedOnLastDisconnect

    public boolean isDisposedOnLastDisconnect()
                                       throws IfsException

  Description copied from class: `S_LibraryService`
  Gets whether this service will be automatically disposed when its last session is disconnected.

  Returns:
    whether the service will be automatically disposed
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setDisposedOnLastDisconnect

    public void setDisposedOnLastDisconnect(boolean dispose)
                                     throws IfsException

  Description copied from class: `S_LibraryService`
  Sets whether this service will be automatically disposed when its last session is disconnected.

  Parameters:
    `dispose` - whether the service will be automatically disposed
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSessionCount

    protected int getSessionCount()
                           throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the number of sessions currently connected to this service.

  Returns:
    the session count
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getAllSessions

    protected S_LibrarySession[] getAllSessions()
                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Gets all connected sessions

  Returns:
    the sessions
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getMaximumConcurrentSessions

    public int getMaximumConcurrentSessions()
                                     throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the maximum number of concurrent sessions for this service.

  Returns:
    the maximum number of concurrent sessions, or 0 if there is no maximum
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setMaximumConcurrentSessions

    public void setMaximumConcurrentSessions(int count)
                                      throws IfsException

  Description copied from class: `S_LibraryService`
  Sets the maximum number of concurrent sessions for this service.

  Specifying a value less than the current session count will not affect any existing sessions, but will prevent any new sessions from connecting until the session count falls below the specified value.

  Parameters:
    `count` - the maximum number of concurrent sessions, or 0 if there is no maximum
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getMaximumConcurrentSessionsPerUser

    public int getMaximumConcurrentSessionsPerUser()
                                            throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the maximum number of concurrent sessions per user for this service.

  This limit does not apply to the `system` user.

  Returns:
    the maximum number of concurrent sessions, or 0 if there is no maximum
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setMaximumConcurrentSessionsPerUser

    public void setMaximumConcurrentSessionsPerUser(int count)
                                             throws IfsException

  Description copied from class: `S_LibraryService`
  Sets the maximum number of concurrent sessions per user for this service.

  This limit does not apply to the `system` user.

  Specifying a value less than the current session count for a user will not affect any existing sessions, but will prevent the user from connecting any new sessions until the session count falls below the specified value.

  Parameters:
    `count` - the maximum number of concurrent sessions, or 0 if there is no maximum
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setBootstrapClassPolicyActionContexts

    public void setBootstrapClassPolicyActionContexts(java.util.HashMap pacs,
                                                      java.lang.String schemaPassword)
                                               throws IfsException

  Description copied from class: `S_LibraryService`
  Puts the service in "policy bootstrap" mode.

  In policy bootstrap mode, the in-play policies are not determined by the ClassPolicyList attribute of CLASSOBJECT and the PolicyList attribute of PUBLICOBJECT, SCHEMAOBJECT, and SYSTEMOBJECT. Instead they are explicitly specified using this method.

  The `pacs` argument must be a HashMap whose names are uppercased ClassObject names, and whose values are Lists of the PolicyActionContexts for the ClassObject's ClassPolicyList. The `getClassPolicyActionContexts` method of PolicyManager returns a value in this form.

  If `pacs` is null, the service is taken out of bootstrap mode.

  Parameters:
    `pacs` - see method description
    `schemaPassword` - the schema password
  Throws:
    `IfsException` - (IFS-20014) if the operation fails
  (Unpublished)

### getBootstrapClassPolicyActionContexts

    protected java.util.HashMap getBootstrapClassPolicyActionContexts()
                                                               throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the "policy bootstrap" PolicyActionContexts.

  In policy bootstrap mode, the in-play policies are not determined by the ClassPolicyList attribute of CLASSOBJECT and the PolicyList attribute of PUBLICOBJECT, SCHEMAOBJECT, and SYSTEMOBJECT. Instead they are explicitly specified using this method.

  The return value is a HashMap whose names are uppercased ClassObject names, and whose values are Lists of the PolicyActionContexts for the ClassObject's ClassPolicyList.

  If the return value is null, the service not in bootstrap mode.

  Returns:
    see method description
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### nextRsn

    public long nextRsn()
                 throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the next resolution sequence number.

  The resolution sequence number is proxy timebase.

  Returns:
    the next RSN
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getRsn

    public long getRsn()
                throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the last-generated resolution sequence number.

  The resolution sequence number is proxy timebase.

  Returns:
    the last RSN
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getAttributesRsn

    public long getAttributesRsn()
                          throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the resolution sequence number at which an attribute was last added or removed.

  Returns:
    the RSN
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### incrementAttributesRsn

    public void incrementAttributesRsn()
                                throws IfsException

  Description copied from class: `S_LibraryService`
  Increments the resolution sequence number at which an attribute was last added or removed.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isAuroraService

    public boolean isAuroraService()
                            throws IfsException

  Description copied from class: `S_LibraryService`
  Gets whether this S_LibraryService is running in Aurora.

  Returns:
    whether this service is running in Aurora
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isPartitioningEnabled

    protected boolean isPartitioningEnabled(S_LibrarySession session)

  Description copied from class: `S_LibraryService`
  checks whether or not partitioning is being used in this instance.

  Returns:
    true if partitioning is enabled
  Throws:
    `IfsException` - if the operation fails
  (Published)

### isLykeEnabled

    protected boolean isLykeEnabled()
                             throws IfsException

  Description copied from class: `S_LibraryService`
  Gets whether there is a ctxsubstr ("LYKE") index on the NAME attribute of PublicObject.

  Returns:
    whether there is a LYKE index
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getGuestUserId

    protected java.lang.Long getGuestUserId(S_LibrarySession session)
                                     throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the ID of the guest user.

  Returns:
    the ID of the guest user.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getVersionString

    public static java.lang.String getVersionString()
                                             throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the version of this S_LibraryService as a string.

  Returns:
    the version
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getVersionNumber

    public static long getVersionNumber()
                                 throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the version of this S_LibraryService as a long.

  Returns:
    the version
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSchemaVersionString

    public java.lang.String getSchemaVersionString()
                                            throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the schema version as a string.

  Returns:
    the version
  Throws:
    `IfsException` - (IFS-20001) if the operation fails
  (Published)

### getEffectiveSchemaVersionString

    public java.lang.String getEffectiveSchemaVersionString()
                                                     throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the effective schema version as a string.

  This can be different from the string returned from `getSchemaVersionString` if a repository parameter with the key EFFECTIVE_SCHEMAVERSION is defined. This parameter is used in some upgrade scenarios.

  Returns:
    the effective schema version
  Throws:
    `IfsException` - (IFS-20001) if the operation fails
  (Published)

### getSchemaVersionNumber

    public long getSchemaVersionNumber()
                                throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the schema version as a long.

  Returns:
    the version
  Throws:
    `IfsException` - (IFS-20001) if the operation fails
  (Published)

### getEffectiveSchemaVersionNumber

    public long getEffectiveSchemaVersionNumber()
                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the effective schema version as a long.

  This can be different from the string returned from `getSchemaVersionNumber` if a repository parameter with the key EFFECTIVE_SCHEMAVERSION is defined. This parameter is used in some upgrade scenarios.

  Returns:
    the version
  Throws:
    `IfsException` - (IFS-20001) if the operation fails
  (Published)

### getDatabaseVersionString

    public static java.lang.String getDatabaseVersionString(java.sql.Connection conn)
                                                     throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the version of the Database as a string.

  Parameters:
    `conn` - the LibraryConnection
  Returns:
    the version
  Throws:
    `IfsException` - (IFS-20133) if the operation fails
  (Published)

### getDatabaseVersionNumber

    public static long getDatabaseVersionNumber(java.sql.Connection conn)
                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the version of the database as a long

  Parameters:
    `conn` - the library connection
  Returns:
    the version
  Throws:
    `IfsException` - (IFS-20133) if the operation fails
  (Published)

### getLocalizer

    public final Localizer getLocalizer()
                                 throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the Localizer of this S_LibraryService.

  Returns:
    the localizer
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSchemaName

    public final java.lang.String getSchemaName()
                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Returns the name of the schema used by this service.

  Returns:
    database schema name
  Throws:
    `IfsException` - if the operation fails

### getResourceString

    public java.lang.String getResourceString(java.lang.String key)
                                       throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the resource string for the specified key.

  The method looks-up the key in each extended resource bundle. If no extended resource bundle contains the key, the default resource bundle (LibraryResources) is used.

  Parameters:
    `key` - the resource bundle key
  Returns:
    the resource string
  Throws:
    `IfsException` - (IFS-12001) if the operation fails
  (Published)

### getResourceString

    public java.lang.String getResourceString(java.lang.String key,
                                              java.lang.Object[] params)
                                       throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the resource string for the specified key, and substitutes the specified parameters into that resource string.

  The method looks-up the key using `getResourceString(key)`. Next, `java.text.MessageFormat` is used to substitute the parameters specified by `params` into the key's value. If a string element of `params` is delimited by brackets, i.e. "`{param}`", then that element is replaced with the value returned by `getResourceString("param")` before being passed to `MessageFormat`.

  Parameters:
    `key` - the resource bundle key
    `params` - an array of Objects to be substituted into the resource bundle message using using `java.text.MessageFormat`
  Returns:
    the formatted resource string
  Throws:
    `IfsException` - (IFS-12006) if the operation fails
  (Published)

### getServiceConfigurationProperty

    public AttributeValue getServiceConfigurationProperty(java.lang.String name)
                                                   throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the specified service configuration property.

  Parameters:
    `name` - the property name
  Returns:
    the property, or null if there is no such property
  Throws:
    `IfsException` - (IFS-20004) if the operation fails
  (Published)

### getServiceConfigurationProperty

    public java.lang.String getServiceConfigurationProperty(java.lang.String name,
                                                            java.lang.String defaultValue)
                                                     throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the value of the specified service configuration property, as a string.

  Parameters:
    `name` - the property name
    `defaultValue` - the default value
  Returns:
    the property value
  Throws:
    `IfsException` - (IFS-20004) if the operation fails
  (Published)

### getServiceConfigurationProperty

    public boolean getServiceConfigurationProperty(java.lang.String name,
                                                   boolean defaultValue)
                                            throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the value of the specified service configuration property, as a boolean.

  Parameters:
    `name` - the property name
    `defaultValue` - the default value
  Returns:
    the property value
  Throws:
    `IfsException` - (IFS-20004) if the operation fails
  (Published)

### getServiceConfigurationProperty

    public int getServiceConfigurationProperty(java.lang.String name,
                                               int defaultValue)
                                        throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the value of the specified service configuration property, as an integer.

  Parameters:
    `name` - the property name
    `defaultValue` - the default value
  Returns:
    the property value
  Throws:
    `IfsException` - (IFS-20004) if the operation fails
  (Published)

### getServiceConfigurationProperty

    public double getServiceConfigurationProperty(java.lang.String name,
                                                  double defaultValue)
                                           throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the value of the specified service configuration property, as a double.

  Parameters:
    `name` - the property name
    `defaultValue` - the default value
  Returns:
    the property value
  Throws:
    `IfsException` - (IFS-20004) if the operation fails
  (Published)

### getRepositoryParameterNames

    protected final java.lang.String[] getRepositoryParameterNames(java.sql.Connection conn,
                                                                   java.lang.String prefix)
                                                            throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the repository parameter names that start with the specified prefix.

  Parameters:
    `conn` - the database connection
    `prefix` - the prefix with which repository parameter names must start to be returned; if null or zero-length, all repository parameter names are returned
  Returns:
    the repository parameter names, or null if none
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getRepositoryParameter

    protected java.lang.String getRepositoryParameter(java.lang.String name)
                                               throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the value of the specified repository parameter.

  Parameters:
    `name` - the parameter name
  Returns:
    the parameter value, or null if there is no parameter with the specified name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getRepositoryParameter

    public static java.lang.String getRepositoryParameter(java.sql.Connection conn,
                                                          java.lang.String name)
                                                   throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the value of the specified repository parameter.

  Parameters:
    `conn` - the JDBC connection
    `name` - the parameter name
  Returns:
    the parameter value, or null if there is no parameter with the specified name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### lockRepositoryParameter

    public static java.lang.String lockRepositoryParameter(java.sql.Connection conn,
                                                           java.lang.String name)
                                                    throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the value of the specified repository parameter, acquiring a row-level lock on it.

  Parameters:
    `conn` - the JDBC connection
    `name` - the parameter name
  Returns:
    the parameter value, or null if there is no parameter with the specified name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getRepositoryParameter

    protected static java.lang.String getRepositoryParameter(java.sql.Connection conn,
                                                             java.lang.String name,
                                                             boolean shouldLock)
                                                      throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the value of the specified repository parameter, acquiring a row-level lock if specified.

  Parameters:
    `conn` - the JDBC connection
    `name` - the parameter name
    `shouldLock` - whether acquire a row-level lock
  Returns:
    the parameter value, or null if there is no parameter with the specified name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setRepositoryParameter

    public static void setRepositoryParameter(java.sql.Connection conn,
                                              java.lang.String name,
                                              java.lang.String value)
                                       throws IfsException

  Description copied from class: `S_LibraryService`
  Sets the value of the specified repository parameter.

  Parameters:
    `conn` - the JDBC connection
    `name` - the parameter name
    `value` - the parameter value
  Throws:
    `IfsException` - if the operation fails
  (Published)

### deleteRepositoryParameter

    public static void deleteRepositoryParameter(java.sql.Connection conn,
                                                 java.lang.String name)
                                          throws IfsException

  Description copied from class: `S_LibraryService`
  Deletes the specified repository parameter.

  Parameters:
    `conn` - the JDBC connection
    `name` - the parameter name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getEncryptedRepositoryParameter

    public static java.lang.String getEncryptedRepositoryParameter(java.sql.Connection conn,
                                                                   java.lang.String name)
                                                            throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the value of the specified repository parameter.

  The specified repository parameter's value is stored encrypted.

  Parameters:
    `conn` - the JDBC connection
    `name` - the parameter name
  Returns:
    the parameter value, or null if there is no parameter with the specified name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setEncryptedRepositoryParameter

    public static void setEncryptedRepositoryParameter(java.sql.Connection conn,
                                                       java.lang.String name,
                                                       java.lang.String value)
                                                throws IfsException

  Description copied from class: `S_LibraryService`
  Sets the value of the specified repository parameter.

  The specified repository parameter's value is stored encrypted.

  Parameters:
    `conn` - the JDBC connection
    `name` - the parameter name
    `value` - the parameter value, up to 127 characters
  Throws:
    `IfsException` - if the operation fails
  (Published)

### verifySchemaVersion

    protected void verifySchemaVersion()
                                throws IfsException

  Description copied from class: `S_LibraryService`
  Checks the validity of the schema version number.

  Throws:
    `IfsException` - (IFS-20002) if the schema version is invalid
    `IfsException` - if the operation otherwise fails
  (Published)

### newContentStreamSerializer

    protected static ContentStreamSerializer newContentStreamSerializer()
                                                                 throws IfsException

  Description copied from class: `S_LibraryService`
  Constructs and returns a ContentStreamSerializer appropriate to the runtime process model.

  Returns:
    the content stream serializer
  Throws:
    `IfsException` - if the operation fails
  (Published)

### registerSubService

    protected void registerSubService(java.lang.String name,
                                      SubService sub)
                               throws IfsException

  Description copied from class: `S_LibraryService`
  Registers a subservice.

  Parameters:
    `name` - the name of the subservice
    `sub` - the subservice
  Throws:
    `IfsException` - if the operation fails
  (Published)

### unregisterSubService

    protected SubService unregisterSubService(java.lang.String name)

  Description copied from class: `S_LibraryService`
  Unregisters a subservice.

  Parameters:
    `name` - the name of the subservice
  Returns:
    the subservice
  (Published)

### findSubService

    protected SubService findSubService(java.lang.String name)
                                 throws IfsException

  Description copied from class: `S_LibraryService`
  Gets a subservice by name.

  Parameters:
    `name` - the name of the subservice
  Returns:
    the subservice
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getAllSubServices

    protected SubService[] getAllSubServices()
                                      throws IfsException

  Description copied from class: `S_LibraryService`
  Gets all registered SubServices.

  The returned array is not sorted in any predictable way.

  Returns:
    the registered SubServices
  Throws:
    `IfsException` - if the operation fails
  (Published)

### disposeSubServiceIgnoreError

    protected void disposeSubServiceIgnoreError(SubService sub)

  Description copied from class: `S_LibraryService`
  Disposes the specified subservice, consuming any thrown IfsException.

  Parameters:
    `sub` - the subservice
  (Published)

### connect

    public S_LibrarySessionInterface connect(Credential credential,
                                             ConnectOptions options)
                                      throws IfsException

  Description copied from class: `S_LibraryService`
  Creates a new session on this S_LibraryService.

  Parameters:
    `credential` - the user credential
    `options` - connect options
  Returns:
    the session
  Throws:
    `IfsException` - (IFS-21008) if the operation fails
  (Published)

### constructSession

    protected S_LibrarySession constructSession()
                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Dynamically constructs an unauthenticated S_LibrarySession.

  Returns:
    the session
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSessionConstructor

    public java.lang.reflect.Constructor getSessionConstructor()
                                                        throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the S_LibrarySession constructor.

  Returns:
    the constructor
  Throws:
    `IfsException` - (IFS-21002) if the operation fails
  (Published)

### addSession

    protected void addSession(S_LibrarySession session)
                       throws IfsException

  Description copied from class: `S_LibraryService`
  Adds the specified S_LibrarySession to the set of sessions managed by this S_LibraryService.

  Parameters:
    `session` - the session
  Throws:
    `IfsException` - if the operation fails
  (Published)

### removeSession

    protected void removeSession(S_LibrarySession session)
                          throws IfsException

  Description copied from class: `S_LibraryService`
  Removes the specified S_LibrarySession from the set of sessions managed by this S_LibraryService.

  Parameters:
    `session` - the session
  Throws:
    `IfsException` - if the operation fails
  (Published)

### verifyMaximumConcurrentSessionsPerUser

    protected void verifyMaximumConcurrentSessionsPerUser(S_LibrarySession session,
                                                          java.lang.Long userId)
                                                   throws IfsException

  Description copied from class: `S_LibraryService`
  Verifies the just-connected session didn't blow out the maximum number of concurrent sessions per user for this service.

  Parameters:
    `session` - the just-connected session
    `userId` - the user id, which hasn't yet been set on the session, requiring it to be passed separately
  Throws:
    `IfsException` - (IFS-20132) if the maximum concurrent sessions was exceeded or IfsException if the operation otherwise fails
  (Published)

### getSystemUserToken

    protected java.lang.Object getSystemUserToken(S_LibrarySession session)
                                           throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the system token that can be used to efficiently clone system sessions.

  Returns:
    the system user token
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getDirectoryService

    public DirectoryService getDirectoryService()
                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the DirectoryService of this S_LibraryService.

  Returns:
    the directory service
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getCredentialNameTokenizer

    public CredentialNameTokenizer getCredentialNameTokenizer()
                                                       throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the CredentialNameTokenizer for this S_LibraryService.

  Returns:
    the CredentialNameTokenizer
  Throws:
    `IfsException` - (IFS-12790) if the operation fails
  (Published)

### getTokenCredential

    public TokenCredential getTokenCredential(java.lang.String token,
                                              java.util.Hashtable parameters,
                                              boolean consume)
                                       throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the previously-created TokenCredential for the specified token.

  Parameters:
    `token` - the token
    `parameters` - the required parameters. For this method to return a TokenCredential, this hashtable must contain a matching entry for every required parameter that was specified in creating the TokenCredential.
    `consume` - whether to decrement the remaining authentication count for this TokenCredential
  Returns:
    the TokenCredential
  Throws:
    `IfsException` - (IFS-10192) if the operation fails
  (Published)

### getGssApiCredential

    public GssApiCredential getGssApiCredential(byte[] inputTicket,
                                                java.util.Hashtable parameters)
                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Gets a new GssApiCredential using the supplied ticket. The inputTicket is vaidated at this time against the GSS provider.

  Parameters:
    `inputTicket` - client supplied GSS api ticket
    `parameters` - currently not used
  Returns:
    GssApiCredential
  Throws:
    `IfsException` - (IFS-10192) if the operation fails
  (Unpublished)

### invalidateTokenCredential

    public void invalidateTokenCredential(java.lang.String token,
                                          java.util.Hashtable parameters)
                                   throws IfsException

  Description copied from class: `S_LibraryService`
  Invalidates the previously-created TokenCredential for the specified token.

  Once invalidated, the token can no longer be used to authenticate.

  Parameters:
    `token` - the token
    `parameters` - the required parameters. For this method to invalidate a TokenCredential, this hashtable must contain a matching entry for every required parameter that was specified in creating the TokenCredential.
  Throws:
    `IfsException` - (IFS-10189) if the operation fails
  (Published)

### getTraceLogger

    public final TraceLogger getTraceLogger()
                                     throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the TraceLogger of this S_LibraryService.

  Specified by:
    `getTraceLogger` in interface `Traceable`
  Returns:
    the trace logger
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isTraced

    public final boolean isTraced(int channel,
                                  int level)
                           throws IfsException

  Description copied from class: `S_LibraryService`
  Gets whether tracing is enabled for the specified channel and level.

  Specified by:
    `isTraced` in interface `Traceable`
  Parameters:
    `channel` - the channel number
    `level` - the level
  Returns:
    whether tracing is enabled
  Throws:
    `IfsException` - (IFS-11201) if the channel is invalid
  (Unpublished)

### trace

    public final void trace(int channel,
                            int level,
                            java.lang.String payload)

  Description copied from class: `S_LibraryService`
  Issues a trace request to the trace logger.

  Specified by:
    `trace` in interface `Traceable`
  Parameters:
    `channel` - the channel number
    `level` - the level
    `payload` - a string containing any additional information to be placed in the trace log
  (Unpublished)

### getWriteableConnectionPool

    protected ConnectionPool getWriteableConnectionPool()
                                                 throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the writeable connection pool for this S_LibraryService.

  Returns:
    the connection pool
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getReadonlyConnectionPool

    protected ConnectionPool getReadonlyConnectionPool()
                                                throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the readonly connection pool for this S_LibraryService.

  Returns:
    the connection pool
  Throws:
    `IfsException` - if the operation fails
  (Published)

### resetConnectionPools

    protected void resetConnectionPools()
                                 throws IfsException

  Description copied from class: `S_LibraryService`
  Resets the connection pools.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### resetConnectionPools

    protected void resetConnectionPools(boolean minimizePools)
                                 throws IfsException

  Description copied from class: `S_LibraryService`
  Resets the connection pools. If "minimize" is specified as true, make the pools as small as possible.

  Parameters:
    `minimizePools` - true if pools are to be constructed minimally
  Throws:
    `IfsException` - if the operation fails
  (Published)

### resetCachedStatements

    protected void resetCachedStatements()
                                  throws IfsException

  Description copied from class: `S_LibraryService`
  Resets the cached statements in the connection pools.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### getEventExchanger

    protected oracle.ifs.server.S_LibraryServiceEventExchanger getEventExchanger()
                                                                          throws IfsException

  Description copied from class: `S_LibraryService`
  Returns the S_LibraryServiceEventExchanger of this S_LibraryService.

  Returns:
    the event exchanger
  Throws:
    `IfsException` - if the operation fails
  (Published)

### registerServiceEventHandler

    public void registerServiceEventHandler(IfsEventHandler handler)
                                     throws IfsException

  Description copied from class: `S_LibraryService`
  Register a Service event handler.

  Parameters:
    `handler` - the handler to register
  Throws:
    `IfsException` - if the operation fails
  (Published)

### deregisterServiceEventHandler

    public void deregisterServiceEventHandler(IfsEventHandler handler)
                                       throws IfsException

  Description copied from class: `S_LibraryService`
  De-register a Service event handler.

  Parameters:
    `handler` - the handler to de-register; if null, de-register all service handlers
  Throws:
    `IfsException` - if the operation fails
  (Published)

### postEvent

    protected void postEvent(IfsEvent event)
                      throws IfsException

  Description copied from class: `S_LibraryService`
  Posts the specified event.

  Parameters:
    `event` - the event
  Throws:
    `IfsException` - if the operation fails
  (Published)

### processEvent

    protected void processEvent(IfsEvent event)
                         throws IfsException

  Description copied from class: `S_LibraryService`
  Processes the specified event.

  Parameters:
    `event` - the event
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleEvent

    public void handleEvent(IfsEvent event)
                     throws IfsException

  Description copied from class: `S_LibraryService`
  Handles the specified event.

  Specified by:
    `handleEvent` in interface `IfsEventHandler`
  Parameters:
    `event` - the event
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getFolderIndexService

    public FolderIndexService getFolderIndexService()

  Description copied from class: `S_LibraryService`
  Gets the FolderIndexService for this S_LibraryService.

  Returns:
    the folder index service
  (Published)

### establishFolderIndexService

    public void establishFolderIndexService()
                                     throws IfsException

  Description copied from class: `S_LibraryService`
  Establish a FolderIndexService on-the-fly. This is called during an installation-mode step of creating the tables necessary for a folder index. This process requires a service that was previously started without a folder index service to establish a FolderIndexService object during the process of building the index, so that the building process can be completed.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### disposeFolderIndexService

    public void disposeFolderIndexService()
                                   throws IfsException

  Description copied from class: `S_LibraryService`
  Dispose the FolderIndexService on-the-fly. This is called during an installation-mode step of dropping the folder index.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getAccessControlListIndexService

    public AccessControlListIndexService getAccessControlListIndexService()

  Description copied from class: `S_LibraryService`
  Gets the AccessControlListIndexService for this S_LibraryService.

  Returns:
    the ACL index service
  (Published)

### getAccessControlListProxyService

    public AccessControlListProxyService getAccessControlListProxyService()

  Description copied from class: `S_LibraryService`
  Gets the AccessControlListProxyService for this S_LibraryService.

  Returns:
    the ACL proxy service
  (Published)

### getAccessControlListDiscoverAccessService

    public AccessControlListDiscoverAccessService getAccessControlListDiscoverAccessService()

  Description copied from class: `S_LibraryService`
  Gets the AccessControlListProxyService for this S_LibraryService.

  Returns:
    the ACL proxy service
  (Published)

### getDirectoryGroupIndexService

    public DirectoryGroupIndexService getDirectoryGroupIndexService()

  Description copied from class: `S_LibraryService`
  Gets the DirectoryGroupIndexService for this S_LibraryService.

  Returns:
    the group index service
  (Published)

### isAclResolutionSynchronous

    public boolean isAclResolutionSynchronous()
                                       throws IfsException

  Description copied from class: `S_LibraryService`
  Returns the ACL resolution mode.

  Returns:
    true if the resolution mode is synchronous; false otherwise
  Throws:
    `IfsException` - (IFS-20001) if the operation fails
  (Published)

### isAuditingEnabled

    protected boolean isAuditingEnabled()

  Description copied from class: `S_LibraryService`
  Returns indication as to whether auditing is enabled.

  Returns:
    true if auditing is enabled; false otherwise

### getAuditCertificateCache

    protected BoundedCache getAuditCertificateCache()

  Description copied from class: `S_LibraryService`
  Gets the AuditCertificate cache.

  Returns:
    the AuditCertificate cache

### getAuditInlineStringCache

    protected BoundedCache getAuditInlineStringCache()

  Description copied from class: `S_LibraryService`
  Gets the Audit cache for inline strings.

  Returns:
    the inline string cache

### getAuditInlineStringReferenceCache

    protected BoundedCache getAuditInlineStringReferenceCache()

  Description copied from class: `S_LibraryService`
  Gets the Audit cache for references to inline strings.

  Returns:
    the inline string reference cache

### disconnectIdleSessions

    protected void disconnectIdleSessions(long currentTime)

  Description copied from class: `S_LibraryService`
  Disconnects S_LibrarySessions that have been idle for longer than the value of the `SessionTimeoutPeriod` parameter in the service properties file.

  The frequency of this check is determined by the value of the `CheckForIdleSessionsPeriod` paramater in the service properties file.

  Parameters:
    `currentTime` - the current time
  (Published)

### getLockrowsTimeoutPeriod

    protected long getLockrowsTimeoutPeriod()

  Description copied from class: `S_LibraryService`
  Gets the timeout period to use for timeout of the lockrows() operation.

  Returns:
    the lock rows timeout period (in seconds)
  (Published)

### sendServiceKeepAliveEvent

    protected void sendServiceKeepAliveEvent(long currentTime)

  Description copied from class: `S_LibraryService`
  Periodically sends a keep-alive IfsEvent to other S_LibraryServices.

  Parameters:
    `currentTime` - the current time
  (Published)

### cleanupDeadServices

    protected void cleanupDeadServices(S_LibrarySession session,
                                       long serviceTimeoutPeriod)
                                throws IfsException

  Description copied from class: `S_LibraryService`
  Cleans up S_LibraryServices that have abnormally terminated.

  Parameters:
    `session` - the session
    `serviceTimeoutPeriod` - the period, in seconds, after which a service for which no keep-alive packets have been received is deemed dead
  Throws:
    `IfsException` - (IFS-20110) if the operation fails
  (Published)

### getCommittedLibraryObjectDataCache

    protected BoundedCache getCommittedLibraryObjectDataCache()

  Description copied from class: `S_LibraryService`
  Gets the committed S_LibraryObjectData cache.

  Returns:
    the committed data cache
  (Published)

### getCommittedLibraryObjectDataCacheConfiguration

    public BoundedCacheConfiguration getCommittedLibraryObjectDataCacheConfiguration()
                                                                              throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the configuration parameters of the committed S_LibraryObjectData cache.

  Refer to the Javadoc of LooselyBoundedCache for additional information on this method.

  Returns:
    the cache configuration
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setCommittedLibraryObjectDataCacheConfiguration

    public void setCommittedLibraryObjectDataCacheConfiguration(BoundedCacheConfiguration configuration)
                                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Alters the configuration of the committed S_LibraryObjectData cache.

  Refer to the Javadoc of LooselyBoundedCache for additional information on this method.

  Parameters:
    `configuration` - the configuration parameters
  Throws:
    `IfsException` - (IFS-10810) if the operation fails
  (Published)

### getCommittedLibraryObjectDataCachePerformance

    public CachePerformance getCommittedLibraryObjectDataCachePerformance()
                                                                   throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the performance information for the committed S_LibraryObjectData cache.

  Returns:
    a cache performance object
  Throws:
    `IfsException` - if the operation fails
  (Published)

### resetCommittedLibraryObjectDataCachePerformance

    public void resetCommittedLibraryObjectDataCachePerformance()
                                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Resets the performance information for the committed S_LibraryObjectData cache.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### getCommittedResolvedAclCache

    protected BoundedCache getCommittedResolvedAclCache()

  Description copied from class: `S_LibraryService`
  Gets the committed resolved ACL cache.

  Returns:
    the committed resolved ACL cache
  (Published)

### getCommittedResolvedAclCacheConfiguration

    public BoundedCacheConfiguration getCommittedResolvedAclCacheConfiguration()
                                                                        throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the configuration parameters of the committed Resolved Acl cache.

  Refer to the Javadoc of LooselyBoundedCache for additional information on this method.

  Returns:
    the cache configuration
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setCommittedResolvedAclCacheConfiguration

    public void setCommittedResolvedAclCacheConfiguration(BoundedCacheConfiguration configuration)
                                                   throws IfsException

  Description copied from class: `S_LibraryService`
  Alters the configuration of the committed Resolved Acl cache.

  Refer to the Javadoc of LooselyBoundedCache for additional information on this method.

  Parameters:
    `configuration` - the configuration parameters
  Throws:
    `IfsException` - (IFS-10810) if the operation fails
  (Published)

### getCommittedResolvedAclCachePerformance

    public CachePerformance getCommittedResolvedAclCachePerformance()
                                                             throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the performance information for the committed Resolved Acl cache.

  Returns:
    a cache performance object
  Throws:
    `IfsException` - if the operation fails
  (Published)

### resetCommittedResolvedAclCachePerformance

    public void resetCommittedResolvedAclCachePerformance()
                                                   throws IfsException

  Description copied from class: `S_LibraryService`
  Resets the performance information for the committed Resolved Acl cache.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### getAuditCertificateCacheConfiguration

    public BoundedCacheConfiguration getAuditCertificateCacheConfiguration()
                                                                    throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the configuration parameters of the AuditCertificate cache.

  Refer to the Javadoc of LooselyBoundedCache for additional information on this method.

  Returns:
    the cache configuration
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setAuditCertificateCacheConfiguration

    public void setAuditCertificateCacheConfiguration(BoundedCacheConfiguration configuration)
                                               throws IfsException

  Description copied from class: `S_LibraryService`
  Alters the configuration of the AuditCertificate cache.

  Refer to the Javadoc of LooselyBoundedCache for additional information on this method.

  Parameters:
    `configuration` - the configuration parameters
  Throws:
    `IfsException` - (IFS-10810) if the operation fails
  (Published)

### getAuditCertificateCachePerformance

    public CachePerformance getAuditCertificateCachePerformance()
                                                         throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the performance information for the AuditCertificate cache.

  Returns:
    a cache performance object
  Throws:
    `IfsException` - if the operation fails
  (Published)

### resetAuditCertificateCachePerformance

    public void resetAuditCertificateCachePerformance()
                                               throws IfsException

  Description copied from class: `S_LibraryService`
  Resets the performance information for the AuditCertificate cache.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### getReadonlyConnectionPoolConfiguration

    public ConnectionPoolConfiguration getReadonlyConnectionPoolConfiguration()
                                                                       throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the configuration parameters of the readonly ConnectionPool.

  Refer to the Javadoc of ConnectionPool for additional information on this method.

  Returns:
    the configuration
  Throws:
    `IfsException` - (IFS-10628) if the operation fails
  (Published)

### setReadonlyConnectionPoolConfiguration

    public void setReadonlyConnectionPoolConfiguration(ConnectionPoolConfiguration configuration)
                                                throws IfsException

  Description copied from class: `S_LibraryService`
  Alters the configuration of the readonly ConnectionPool.

  Refer to the Javadoc of ConnectionPool for additional information on this method.

  Parameters:
    `configuration` - the configuration parameters
  Throws:
    `IfsException` - (IFS-10629) if the operation fails
  (Published)

### getReadonlyConnectionPoolPerformance

    public ConnectionPoolPerformance getReadonlyConnectionPoolPerformance()
                                                                   throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the performance information for the readonly ConnectionPool.

  Returns:
    a connection pool performance object
  Throws:
    `IfsException` - (IFS-10624) if the operation fails
  (Published)

### resetReadonlyConnectionPoolStatistics

    public void resetReadonlyConnectionPoolStatistics()
                                               throws IfsException

  Description copied from class: `S_LibraryService`
  Resets the performance statistics of the readonly ConnectionPool.

  Throws:
    `IfsException` - (IFS-10625) if the operation fails
  (Published)

### getWriteableConnectionPoolConfiguration

    public ConnectionPoolConfiguration getWriteableConnectionPoolConfiguration()
                                                                        throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the configuration parameters of the writeable ConnectionPool.

  Refer to the Javadoc of ConnectionPool for additional information on this method.

  Returns:
    the configuration
  Throws:
    `IfsException` - (IFS-10628) if the operation fails
  (Published)

### setWriteableConnectionPoolConfiguration

    public void setWriteableConnectionPoolConfiguration(ConnectionPoolConfiguration configuration)
                                                 throws IfsException

  Description copied from class: `S_LibraryService`
  Alters the configuration of the writeable ConnectionPool.

  Refer to the Javadoc of ConnectionPool for additional information on this method.

  Parameters:
    `configuration` - the configuration parameters
  Throws:
    `IfsException` - (IFS-10629) if the operation fails
  (Published)

### getWriteableConnectionPoolPerformance

    public ConnectionPoolPerformance getWriteableConnectionPoolPerformance()
                                                                    throws IfsException

  Description copied from class: `S_LibraryService`
  Gets the performance information for the writeable ConnectionPool.

  Returns:
    a connection pool performance object
  Throws:
    `IfsException` - (IFS-10624) if the operation fails
  (Published)

### resetWriteableConnectionPoolStatistics

    public void resetWriteableConnectionPoolStatistics()
                                                throws IfsException

  Description copied from class: `S_LibraryService`
  Resets the performance statistics of the writeable ConnectionPool.

  Throws:
    `IfsException` - (IFS-10625) if the operation fails
  (Published)

### disconnectSession

    public void disconnectSession(java.lang.Long sessionId)
                           throws IfsException

  Description copied from class: `S_LibraryService`
  Disconnects the specified session.

  Parameters:
    `sessionId` - the id of the session to be disconnected
  Throws:
    `IfsException` - (IFS-20104) if the operation fails
  (Published)

### getPolicyAction

    protected PolicyAction getPolicyAction(java.lang.String className)
                                    throws IfsException

  Description copied from class: `S_LibraryService`
  Finds a PolicyAction specified by fully-qualified classname.

  Parameters:
    `className` - the fully-qualified class name of the PolicyAction
  Returns:
    the PolicyAction, or null if no PolicyAction is cached
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### putPolicyAction

    protected void putPolicyAction(java.lang.String className,
                                   PolicyAction pa)
                            throws IfsException

  Description copied from class: `S_LibraryService`
  Caches a PolicyAction specified by fully-qualified classname.

  Parameters:
    `className` - the fully-qualified class name of the PolicyAction
    `pa` - the PolicyAction
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### removePolicyAction

    protected void removePolicyAction(java.lang.String className)
                               throws IfsException

  Description copied from class: `S_LibraryService`
  Removes a PolicyAction specified by fully-qualified classname.

  Parameters:
    `className` - the fully-qualified class name of the PolicyAction
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### throwUnexpectedException

    protected static void throwUnexpectedException(java.lang.String methodname,
                                                   java.lang.Exception e)
                                            throws IfsException

  Description copied from class: `S_LibraryService`
  Throws an unexpected exception.

  Do not use.

  Parameters:
    `methodname` - the exception payload
    `e` - the base exception
  Throws:
    `IfsException` - (IFS-9997) always
  (Unpublished)

### closeResultSet

    public static void closeResultSet(java.sql.ResultSet rset)

  Description copied from class: `S_LibraryService`
  Try our best to close a resultSet; no exceptions thrown

  Parameters:
    `rset` - the ResultSet
  (Published)

### closeStatement

    public static void closeStatement(java.sql.Statement stmt)

  Description copied from class: `S_LibraryService`
  Try our best to close a Statement; no exceptions thrown

  Parameters:
    `stmt` - the Statement
  (Published)

### closeStatement

    public static void closeStatement(StatementWrapper stmt)

  Description copied from class: `S_LibraryService`
  Try our best to close a wrapped Statement; no exceptions thrown

  Parameters:
    `stmt` - the StatementWrapper
  (Published)

### getCurrentTime

    protected static long getCurrentTime()

  Description copied from class: `S_LibraryService`
  Returns the current time as a long, appropriate for storing in the database. The current time will have the milliseconds truncated, so that it is equivalent to: new Timestamp(System.currentTimeMillis()).getTime();

  Returns:
    the current date, with milliseconds truncated
  (Published)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD